<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="序号" prop="orderNo">
        <el-input
          v-model="queryParams.orderNo"
          placeholder="请输入序号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="位置" prop="position">
        <el-input
          v-model="queryParams.position"
          placeholder="请输入位置"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="责任人" prop="personLiable">
        <el-input
          v-model="queryParams.personLiable"
          placeholder="请输入责任人"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="房间号" prop="roomNo">
        <el-input
          v-model="queryParams.roomNo"
          placeholder="请输入房间号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['production:region:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['production:region:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['production:region:remove']"
        >删除
        </el-button>
      </el-col>
      <!--      <el-col :span="1.5">
              <el-button
                type="info"
                icon="el-icon-upload2"
                size="mini"
                @click="handleImport"
                v-hasPermi="['production:region:edit']"
              >导入
              </el-button>
            </el-col>
            <el-col :span="1.5">
              <el-button
                type="warning"
                icon="el-icon-download"
                size="mini"
                @click="handleExport"
                v-hasPermi="['production:region:export']"
              >导出
              </el-button>
            </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="regionList" @selection-change="handleSelectionChange" :height="clientHeight"
              border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="装置名称" align="center" prop="plantCode" :show-overflow-tooltip="true"/>
      <el-table-column label="序号" align="center" prop="orderNo" :show-overflow-tooltip="true"/>
      <el-table-column label="位置" align="center" prop="position" :show-overflow-tooltip="true"/>
      <el-table-column label="责任人" align="center" prop="personLiable" :show-overflow-tooltip="true"/>
      <el-table-column label="房间号" align="center" prop="roomNo" :show-overflow-tooltip="true"/>
      <el-table-column label="区域标准状态照片" align="center" prop="fileId" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <div v-if="scope.row.fileId">
            <el-button type="text" @click="openFile(scope.row.fileId)"><i class="el-icon-picture-outline"/>查看
            </el-button>
          </div>
          <div v-else>
            NA
          </div>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" fixed="right" width="180" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="generateExcel(scope.row)"
            v-hasPermi="['production:region:edit']"
          >下载
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['production:inspection:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['production:inspection:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改区域列台账对话框 -->
    <el-dialog  :close-on-click-modal="false" :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="130px">
        <el-form-item label="装置名称" prop="plantCode">
          <el-input v-model="form.plantCode" placeholder="请输入装置名称"/>
        </el-form-item>
        <el-form-item label="序号" prop="orderNo">
          <el-input v-model="form.orderNo" placeholder="请输入序号"/>
        </el-form-item>
        <el-form-item label="位置" prop="position">
          <el-input v-model="form.position" placeholder="请输入位置"/>
        </el-form-item>
        <el-form-item label="责任人是否为系统中人员" prop="inSys">
          <el-radio v-model="form.inSys" label="是">是</el-radio>
          <el-radio v-model="form.inSys" label="否">否</el-radio>
        </el-form-item>
        <el-form-item label="责任人姓名" prop="personLiable" v-if="form.inSys=='否'">
          <el-input v-model="form.personLiable" placeholder="请输入责任人姓名"/>
        </el-form-item>
        <el-form-item label="责任人照片" prop="personFile" v-if="form.inSys=='否'">
          <el-upload
            ref="file"
            :headers="file.headers"
            :action="file.url"
            :disabled="file.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess2"
            :on-remove="handleRemove"
            :auto-upload="true"
            accept=".jpg,.png"
            :multiple="true"
            :limit="4"
            :on-exceed="exceedFile"
            :file-list="userFileList"
            list-type="picture-card"
          >
            <i class="el-icon-plus"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="责任人" prop="staffId" v-if="form.inSys=='是'">
          <el-select v-model="form.staffId" filterable multiple clearable placeholder="请选择责任人"
                     style="width: 100%">
            <el-option v-for="staff in staffList"
                       :key="staff.staffid"
                       :label="staff.name+'_'+staff.staffid"
                       :value="staff.staffid"/>
          </el-select>
        </el-form-item>
        <el-form-item label="房间号" prop="roomNo">
          <el-input v-model="form.roomNo" placeholder="请输入房间号"/>
        </el-form-item>
        <el-form-item label="区域标准状态照片" prop="fileId">
          <el-upload
            ref="file"
            :headers="file.headers"
            :action="file.url"
            :disabled="file.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess"
            :on-remove="handleRemove"
            :auto-upload="true"
            accept=".jpg,.png"
            :multiple="true"
            :limit="4"
            :on-exceed="exceedFile"
            :file-list="fileList"
            list-type="picture-card"
          >
            <i class="el-icon-plus"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog  :close-on-click-modal="false" title="区域标准状态照片" :visible.sync="file.open">
      <div>
        <el-image
          style="width: 30%; height: 30%;margin:10px;border-radius: 5%;vertical-align: middle;'"
          v-for="url in srcList"
          :src="url"
          :preview-src-list="srcList">
        </el-image>
      </div>
    </el-dialog>

    <!-- 用户导入对话框 -->
    <el-dialog  :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listRegion,
  getRegion,
  delRegion,
  addRegion,
  updateRegion,
  exportRegion,
  importTemplate, generateExcel
} from "@/api/production/region";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {getFile} from "@/api/production/file";
import {listOgzStaffmgr, listStaffmgrAll} from "@/api/plant/staffmgr";

export default {
  name: "Region",
  components: {Treeselect},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      srcList: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 区域列台账表格数据
      regionList: [],
      staffList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/production/region/importData"
      },
      fileList: [],
      userFileList: [],
      file: {
        file: "",
        open: false,
        // 是否禁用上传
        isUploading: false,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/production/file/uploadFile",
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        plantCode: null,
        orderNo: null,
        position: null,
        personLiable: null,
        roomNo: null,
        fileId: null,
        remarks: null,
        status: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        inSys: null,
        personFile: null,
        staffId: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        plantCode: [
          {required: true, message: "请输入装置名称", trigger: "blur"}
        ],
        orderNo: [
          {required: true, message: "请输入区域序号", trigger: "blur"}
        ],
        position: [
          {required: true, message: "请输入区域位置", trigger: "blur"}
        ],
        inSys: [
          {required: true, message: "请选择责任人是否为系统中人员", trigger: "blur"}
        ],
        personLiable: [
          {required: true, message: "请输入责任人姓名", trigger: "blur"}
        ],
        staffId: [
          {required: true, message: "请选择责任人", trigger: "blur"}
        ],
      },
      fileIds: [],
      personFiles: []
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 250
    })
    this.getList();
    this.getTreeselect();
    this.getStaff();
  },
  methods: {
    // 文件超出个数限制时的钩子
    exceedFile(files, fileList) {
      this.$message.warning(
        `最多支持4个文件导入，共选择了 ${files.length + fileList.length} 个文件`
      );
    },
    generateExcel(row) {
      console.log(row.id)
      this.$confirm('确认下载当前数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return generateExcel(row.id);
      }).then(response => {
        var name = response.msg;
        name = name.substring(name.lastIndexOf('/'), name.length);
        var url = response.msg;
        var suffix = url.substring(url.lastIndexOf("."), url.length);
        const a = document.createElement('a')
        a.setAttribute('download', name)
        a.setAttribute('target', '_blank')
        a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
        a.click()
      })
    },
    getStaff() {
      listOgzStaffmgr({}).then(res => {
        this.staffList = res
      })
    },
    openFile(fileIds) {
      console.log(fileIds)
      this.file.open = true;
      this.srcList = [];
      let ids = fileIds.split(',');
      console.log(ids)
      for (let id of ids) {
        console.log(id)
        getFile(id).then(res => {
          this.srcList.push(process.env.VUE_APP_BASE_API + res.data.url)
        })
      }
    },
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.file.file = file;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      this.fileIds.push(response.data);
    },
    handleRemove(file, fileList){
      console.log(this.fileIds,this.personFiles)
      console.log(file)
      if(file.response.data!=null){
        if (this.fileIds.indexOf(file.response.data)>=0){
          this.fileIds.splice(this.fileIds.indexOf(file.response.data),1)
        }
        if (this.personFiles.indexOf(file.response.data)>=0){
          this.personFiles.splice(this.personFiles.indexOf(file.response.data),1)
        }
      }
      console.log(this.fileIds,this.personFiles)
    },
    //附件上传成功处理
    handleFileDocSuccess2(response, file, fileList) {
      this.personFiles.push(response.data);
    },
    /** 查询区域列台账列表 */
    getList() {
      this.loading = true;
      listRegion(this.queryParams).then(response => {
        this.regionList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plantCode: null,
        orderNo: null,
        position: null,
        personLiable: null,
        roomNo: null,
        fileId: null,
        remarks: null,
        status: 0,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        inSys: null,
        personFile: null,
        staffId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.fileIds = [];
      this.personFiles = [];
      this.fileList = [];
      this.userFileList = [];
      this.open = true;
      this.title = "添加区域列台账";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.fileIds = [];
      this.personFiles = [];
      this.fileList = [];
      this.userFileList = [];
      const id = row.id || this.ids
      getRegion(id).then(response => {
        this.form = response.data;
        if (this.form.staffId != null)
          this.form.staffId = this.form.staffId.split(",");
        if (this.form.fileId!=null){
          let ids = this.form.fileId.split(',')
          for (const id of ids) {
            getFile(id).then(res=>{
              let item = {url: process.env.VUE_APP_BASE_API +res.data.url,response: {msg: res.data.url,data:id} }
              this.fileList.push(item)
              this.fileIds.push(id)
            })
          }
        }
        if (this.form.personFile!=null){
          let ids = this.form.personFile.split(',')
          for (const id of ids) {
            getFile(id).then(res=>{
              let item = {url: process.env.VUE_APP_BASE_API +res.data.url,response: {msg: res.data.url,data:id} }
              this.userFileList.push(item)
              this.personFiles.push(id)
            })
          }
        }
        console.log(this.fileIds,this.personFiles)
        this.open = true;
        this.title = "修改区域列台账";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.fileIds != []) {
            this.form.fileId = this.fileIds.join(',');
          }
          if (this.personFiles != []) {
            this.form.personFile = this.personFiles.join(',');
          }
          if (this.form.staffId != null && this.form.staffId != []) {
            let names = [];
            for (const staffId of this.form.staffId) {
              names.push(this.staffList.find((o) => o.staffid === staffId).name);
            }
            this.form.staffId = this.form.staffId.join(',');
            this.form.personLiable = names.join(',')
          }
          console.log(this.form)
          if (this.form.id != null) {
            updateRegion(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRegion(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delRegion(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有区域列台账数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportRegion(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
